SuperStrict

SeedRnd MilliSecs()

Graphics 800, 600, 0, 60

Global mask:TImage = LoadImage("terrain.png")
Global fill:TImage = LoadImage("money.png")
Global ger:TImage = LoadAnimImage("germoney_anim.png", 64, 64, 0, 3)
Global gr:TImage = LoadAnimImage("greece_anim.png", 64, 64, 0, 3)
Global bomb:TImage = LoadImage("bomb.png")
Global arrow:TImage = LoadImage("arrow.png")
Global img:TImage = CreateTerrain(mask, fill)

MidHandleImage(arrow)

Global base:Int[,] = CreateBaseLine( img )

Global gerx:Int, gery:Int, gerangle:Int, gerlives:Int, gerstate:Int, gertext:String = "", gerrdy:Int
Global grx:Int, gry:Int, grangle:Int, grlives:Int, grstate:Int, grtext:String = "", grrdy:Int
Global bx:Float, by:Float, bs:Float, bcs:Float, bsd:Int, bsy:Float, bangle:Float, bshot:Int, bt:Float
Global turn:Int

SetBlend ALPHABLEND
SetClsColor 179, 209, 241

bsd = 1
turn = 0

gerx = Rand(64, 336)
gery = 0
gerangle = 0
gerlives = 5

grx = Rand( 400, 736 )
gry = 0
grangle = 0
grlives = 5

bs = 7
bcs = 5

Repeat
	Cls()

		If Not CheckBaseLine(base, gerx + 32, gery + 32, 1, 32) Then
			gery:+ 2
		Else
			gerrdy = True
		End If
			
		If Not CheckBaseLine(base, grx + 32, gry + 32, 1, 32) Then
			gry:+ 2
		Else
			grrdy = True
		End If	
		
		If turn = 0 And gerrdy And grrdy Then turn = Rand(1,2)

		'GAME LOGIC
		If turn <> -1
			If MouseHit( MOUSE_LEFT ) Then
				DestroyTerrain( img, MouseX(), MouseY(), 50 )
				base = CreateBaseLine( img )
			End If
			
			If KeyDown( KEY_UP ) Then
				If turn = 1
					gerangle:+ 1
					If gerangle > 60 Then
						gerangle = 60
					EndIf
				Else If turn = 2
					grangle:+ 1
					If grangle > 60 Then
						grangle = 60
					EndIf
				End If
			EndIf
			
			If KeyDown( KEY_DOWN ) Then
				If turn = 1
					gerangle:- 1
					If gerangle < -60 Then
						gerangle = -60
					EndIf
				Else If turn = 2
					grangle:- 1
					If grangle < -60 Then
						grangle = -60
					EndIf
				End If		End If
			
			If KeyHit( KEY_SPACE ) Then
				If turn = 1 Then
					Shoot( gerx + 32, gery + 32, gerangle )
				Else If turn = 2 Then
					Shoot( grx + 32, gry + 32, grangle )
				End If
				
				gerstate = 0
				grstate = 0
				'Print "bomb speed: " + bcs
			End If
			
			If bshot Then
			
				bx:+ bs * Sin(bangle) * bt
				by:- bsy * Cos(bangle) * bt
				
				bsy:- 0.1 * bt
				bt:+ 0.05
							
				If CheckBaseLine( base, bx + 16, by + 16, 1, 16 ) Then
					DestroyTerrain( img, bx + 16, by + 16, 50 )
					base = CreateBaseLine( img )
					bshot = False
					SwitchTurn()
				Else If CheckBombPlayer( gerx + 32, gery + 32, bx + 16, by + 16, 32, 16 )
					gerlives:- 1
					gerstate = 1
					grstate = 2
					bshot = False
					SwitchTurn()
					DrawGreeceText( )
					If gerlives = 0 Then 
						turn = -1
						gertext = ""
					End If
				Else If CheckBombPlayer( grx + 32, gry + 32, bx + 16, by + 16, 32, 16 )
					grlives:- 1
					grstate = 1
					gerstate = 2
					bshot = False
					SwitchTurn()
					DrawGermoneyText( )
					If grlives = 0 Then
						turn = -1
						gertext = ""
					End If
				Else If by > 600 Or bx < 0 Or bx > 800
					bshot = False
					SwitchTurn()
				End If
			
			Else
				bcs:+ bsd * 0.1
				
				If bcs < bs * 0.5
					bcs = bs * 0.5
					bsd:* -1
				Else If bcs > bs
					bcs = bs
					bsd:* -1
				End If
			End If
		End If
		
		'DRAW
		
		DrawImage( img, 0, 0 )
		
		DrawImage( ger, gerx, gery, gerstate )
		DrawImage( gr, grx, gry, grstate )
		
		SetColor( 164, 0, 0 )
			If turn = 1
				DrawRect( gerx, gery - 40, (bcs - 3.5) / 3.5 * 64, 8 )
			Else If turn = 2
				DrawRect( grx, gry - 40, (bcs - 3.5) / 3.5 * 64, 8 )
			End If
		SetColor( 255, 255, 255 )
		
		If turn = 1
			DrawArrow( arrow, gerx + 32, gery + 32, gerangle )
		Else If turn = 2
			DrawArrow( arrow, grx + 32, gry + 32, grangle )
		End If
		
		DrawLives()
		
		If bshot
			SetRotation(bangle)
			DrawImage( bomb, bx, by )
			SetRotation(0)		
		End If
		
		If gertext <> ""
			SetColor( 255, 255, 255)
			DrawText( gertext, gerx + 32 - TextWidth( gertext ) / 2, gery - 80 )
			DrawText( grtext, grx + 32 - TextWidth( grtext ) / 2, gry - 80 )
			SetColor( 255, 255, 255 )
		End If
		
		If turn = -1
			SetColor( 0, 0, 0 )
			If gerlives = 0
				DrawText( "Germoney gives monies", 400 - TextWidth( "Germoney gives monies" ) / 2, 100 )
			Else If grlives = 0
				DrawText( "Germoney keeps monies", 400 - TextWidth( "Germoney keeps monies" ) / 2, 100 )
			End If
			SetColor( 255, 255, 255 )
		End If
		
	Flip()
	
Until KeyHit(KEY_ESCAPE) Or AppTerminate()

Function CreateTerrain:TImage( mask:TImage, fill:TImage )

    Local px:TPixmap, px1:TPixmap, px2:TPixmap

    px = LockImage(fill)
    px1 = LockImage(mask)
    px2 = CreatePixmap( 800, 600, PF_RGBA8888 )

	ClearPixels(px2, $00000000)
	
	For Local y:Int = 0 Until 600 Step 128
		For Local x:Int = 0 Until 800 Step 128
			For Local y2:Int = 0 Until 128
				For Local x2:Int = 0 Until 128
					'Print("Trying pixel at" + (x+x2) + " | " + (y+y2)) 
					If x + x2 < 800 And y + y2 < 600 And ReadPixel( px1, x + x2, y + y2 ) = $FFFFFFFF Then
						'Print("White pixel at" + (x+x2) + " | " + (y+y2))
						WritePixel(px2, x + x2, y + y2, ReadPixel( px, x2, y2 ) )
					End If	
				Next
			Next
		Next
	Next
	
	UnlockImage( fill )
	UnlockImage( mask)
	
	Return LoadImage(px2)
End Function

Function DestroyTerrain( img:TImage, x:Int, y:Int, r:Int )

	Local px:TPixmap = LockImage( img )
	Local pxmask:TPixmap = LockImage( mask )
	
	For Local dy:Int = (y-r) To (y+r)
		For Local dx:Int = (x-r) To (x+r)
			Local d:Float = Sqr( ( (x - dx) * (x - dx) ) + ( (y - dy) * (y - dy) ) )
			
			If dx >= 0 And dy >= 0 And dx < 800 And dy < 600 And d < 1 + r Then
				WritePixel( px, dx, dy, $00000000 )
				'WritePixel( pxmask, dx, dy, $00000000 )
			End If
		Next
	Next

	UnlockImage( mask )
	UnlockImage( img )

End Function

Function CreateBaseLine:Int[,]( img:TImage )

	Local px:TPixmap = LockImage( img )
	Local base:Int[800,600]
	Local col:Int = $FFFFFFFF
	
	For Local x:Int = 0 Until 800
	 	For Local y:Int = 0 Until 600
			If ReadPixel( px, x, y ) <> $00000000 Then
				For Local y2:Int = -1 To 1
					For Local x2:Int = -1 To 1
						If x + x2 >= 0 And x + x2 < 800 And y + y2 >= 0 And y + y2 < 600 Then
							col = col & ReadPixel( px, x + x2, y + y2 )
						End If
					Next
				Next
				
				If col = $00000000 Then
					'WritePixel( px, x, y, $FF Shl 24 | $FF Shl 16 | $00 Shl 8 | $00 ) 
					base[x,y] = True
				End If
				
				col = $FFFFFFFF
			End If
		Next
	Next
	
	UnlockImage(img)
	
	Return base
End Function

Function CheckBaseLine:Int( base:Int[,] Var, x:Int, y:Int, r1:Int, r2:Int )
	
	For Local dx:Int = (x-r2) To (x+r2)
		For Local dy:Int = 0 Until 600
			
			If dx >= 0 And dx < 800 And dy >= 0 And dy < 600 And base[dx,dy] Then
			
				Local d:Float = Sqr( ( (x - dx) * (x - dx) ) + ( (y - dy) * (y - dy) ) )
			 
				If d < r1 + r2 Then
					Return True
				EndIf
			End If
		Next
	Next
	
	Return False
End Function

Function DrawArrow( img:TImage, x:Int, y:Int, angle:Int )

	SetRotation(angle)
	DrawImage( img, x + 50 * Sin(angle), y - 50 * Cos(angle) )
	SetRotation(0)
	
End Function

Function Shoot( x:Int, y:Int, angle:Int )
	
	bt = 0
	
	bx = x - 16 + 50 * Sin(angle)
	by = y - 82 * Cos(angle)
	
	bsy = bcs
		
	bangle = angle
	
	bshot = True
	
End Function

Function CheckBombPlayer:Int( x:Int, y:Int, x2:Int, y2:Int, r1:Int, r2:Int )

	Local d:Float = Sqr( ( (x - x2) * (x - x2) ) + ( (y - y2) * (y - y2) ) )
			 
	If d < r1 + r2 Then
		Return True
	EndIf	

	Return False
	
End Function

Function DrawLives()
	
	SetScale 0.25, 0.25
	For Local i:Int = 0 Until gerlives
		DrawImage( ger, 24 + i * 24, 24 )
	Next
	
	For Local i:Int = 0 Until grlives
		DrawImage( gr, 760 - i * 24, 24 )
	Next
	SetScale 1, 1
End Function

Function SwitchTurn()

	If turn = 1
		turn = 2
	Else If turn = 2
		turn = 1
	End If
	
	gerangle = 0
	grangle = 0
	
	gertext = ""
		
End Function

Function DrawGermoneyText( )
	
	Select Rand( 0, 2 )
		Case 0
			gertext = "Gib debts!"
			grtext = "Oxi!"
		Case 1
			gertext = "Yuo ruin Yurup monies!"
			grtext = "Gib moar Yuro pls"
		Case 2
			gertext = "Bombe not of need of givings back!"
			grtext = "Germoney will knowings glory greeces bombs!"
	End Select
	
End Function

Function DrawGreeceText( )
	
	Select Rand( 0, 2 )
		Case 0
			gertext = "Nein nein nein!"
			grtext = "Yurup pays monies"
		Case 1
			gertext = "Yuo not mussen overact it greecy!"
			grtext = "Payings with olives yes?"
		Case 2
			gertext = "Debt you payings will!!!"
			grtext = "Debt, what debt Germoney?"
	End Select
	
End Function